  Member
  Include('tSQLite.inc')

  Map
    Module('SQLite Api')
      sqlite3_errmsg(Long),Long,C
      sqlite3_free(Long),C
      sqlite3_exec(Long,*cString,Long,Long,Long),Long,C,Raw
      sqlite3_close(Long),Long,C,Proc
      sqlite3_open(*cString,Long),Long,C,Raw
      sqlite3_progress_handler(Long,Long,Long,Long),C
      sqlite3_busy_timeout(Long,Long),Long,C,Proc

      sqlite3_prepare(       Long sqlite3,*CString zSql, Long nByte, Long sqlite3_stmt, Long pzTail),Long,C,Raw
      sqlite3_column_count(  Long sqlite3_stmt),Long,C
      sqlite3_step(          Long sqlite3_stmt),Long,C
      sqlite3_finalize(      Long sqlite3_stmt),Long,C,Proc

      sqlite3_column_type(   Long sqlite3_stmt, Long NumCol),Long,C          !  
      sqlite3_column_name(   Long sqlite3_stmt, Long NumCol),*CString,C,Raw  !  
      sqlite3_column_bytes(  Long sqlite3_stmt, Long NumCol),Long,C          !  
      
      sqlite3_column_int(    Long sqlite3_stmt, Long NumCol),Long,C
      sqlite3_column_double( Long sqlite3_stmt, Long NumCol),Real,C
      sqlite3_column_text(   Long sqlite3_stmt, Long NumCol),*CString,C,Raw
      sqlite3_column_blob(   Long sqlite3_stmt, Long NumCol),ULong,C

      sqlite3_reset(         Long sqlite3_stmt),Long,C,Proc
      sqlite3_clear_bindings(Long sqlite3_stmt),Long,C,Proc
      sqlite3_bind_blob(     Long, Long, const *Long, Long, Long),Long,C

      !    sqlite3_bind_blob(sqlite3_stmt*, int, const void*, int n, void(*)(void*)),Long,C,Raw
      !int sqlite3_bind_blob(sqlite3_stmt*, int, const void*, int n, void(*)(void*));
      !int sqlite3_bind_double(sqlite3_stmt*, int, double);
      !int sqlite3_bind_int(sqlite3_stmt*, int, int);
      !int sqlite3_bind_int64(sqlite3_stmt*, int, sqlite3_int64);
      !int sqlite3_bind_null(sqlite3_stmt*, int);
      !int sqlite3_bind_text(sqlite3_stmt*, int, const char*, int n, void(*)(void*));
      !int sqlite3_bind_text16(sqlite3_stmt*, int, const void*, int, void(*)(void*));
      !int sqlite3_bind_value(sqlite3_stmt*, int, const sqlite3_value*);
      !int sqlite3_bind_zeroblob(sqlite3_stmt*, int, int n);
    end
    Module('Win32 api')
      TOY::WideCharToMultiByte(UNSIGNED Codepage=0,USHORT dwFlags=0,ULong LpWideCharStr, Long cchWideChar, ULong lpMultuByteStr, |
                               Long cbMultiByte,Ulong LpDefalutChar,BYTE lpUsedDefalutChar),Raw,UNSIGNED,Pascal,NAME('WideCharToMultiByte')

      TOY::MultiByteToWideChar(UNSIGNED Codepage=0,USHORT dwFlags=0,ULong LpMultuByteStr,Long cbMultiByte, ULong LpWideCharStr,|
                               Long cchWideChar),UNSIGNED,RAW,PASCAL,NAME('MultiByteToWideChar')
      TOY::GETACP(),RAW,USHORT,PASCAL,NAME('GETACP')

      TOY::GetLastError(),LONG,PASCAL,NAME('GetLastError')
      TOY::CreateFile(*CSTRING,ULONG,ULONG,LONG,ULONG,ULONG,UNSIGNED=0),UNSIGNED,RAW,PASCAL,NAME('CreateFileA')
      TOY::WriteFile(LONG,*String,LONG,*LONG, LONG),LONG,PASCAL,RAW,PROC,NAME('WriteFile')
      TOY::GetFileSize(LONG hFile, *LONG FileSizeHigh),LONG,RAW,PASCAL,NAME('GetFileSize')
      TOY::ReadFile(LONG hFile, LONG lpBuffer, LONG dwBytes, *LONG dwBytesRead, LONG lpOverlapped),BOOL,RAW,PASCAL,NAME('ReadFile')
      TOY::CloseHandle(UNSIGNED),BOOL,PASCAL,RAW,PROC,NAME('CloseHandle')

      TOY::CoCreateGuid(*?),UNSIGNED,PASCAL,Raw,Name('CoCreateGuid')
      TOY::StringFromGUID2(*?,*?,LONG cchMax),UNSIGNED,PASCAL,Raw,Name('StringFromGUID2')
      TOY::GetDiskFreeSpace(Long,Long,Long,Long,Long),Raw,Pascal,Name('GetDiskFreeSpaceA')
      TOY::MemCpy(Long,Long,Long),Name('_memcpy')
    end

    Module('tSQLite.clw')                             !  
      TOY::ANSItoUTF8(String sStr),String             !   ANSI -> UTF8
      TOY::UTF8toANSI(String sStr),String             !   UTF8 -> ANSI
      TOY::GetGUID(),String                           !  GUID
      TOY::Mess(String sText,String sScene)           !  
      TOY::LoadStrFromFile(String sFileName),*String  !    
                                                      !    
      TOY::WriteStrToFile(String sFileName,String sData),Byte,Proc
    end

    Include('CWUTIL.INC'),Once
  end

TOY::MaxSizeBlob              Equate(1048576)    !     BLOB     SQLite (1 MByte) <-   !
INVALID_HANDLE_VALUE          Equate(  -1)

SQLITE_OK                     Equate(   0)       ! /* Successful result */
SQLITE_ERROR                  Equate(   1)       ! /* SQL error or missing database */
SQLITE_INTERNAL               Equate(   2)       ! /* An internal logic error in SQLite */
SQLITE_PERM                   Equate(   3)       ! /* Access permission denied */
SQLITE_ABORT                  Equate(   4)       ! /* Callback routine requested an abort */
SQLITE_BUSY                   Equate(   5)       ! /* The database file is locked */
SQLITE_LOCKED                 Equate(   6)       ! /* A table in the database is locked */
SQLITE_NOMEM                  Equate(   7)       ! /* A malloc() failed */
SQLITE_READONLY               Equate(   8)       ! /* Attempt to write a readonly database */
SQLITE_INTERRUPT              Equate(   9)       ! /* Operation terminated by sqlite_interrupt() */
SQLITE_IOERR                  Equate(  10)       ! /* Some kind of disk I/O error occurred */
SQLITE_CORRUPT                Equate(  11)       ! /* The database disk image is malformed */
SQLITE_NOTFOUND               Equate(  12)       ! /* (Internal Only) Table or record not found */
SQLITE_FULL                   Equate(  13)       ! /* Insertion failed because database is full */
SQLITE_CANTOPEN               Equate(  14)       ! /* Unable to open the database file */
SQLITE_PROTOCOL               Equate(  15)       ! /* Database lock protocol error */
SQLITE_EMPTY                  Equate(  16)       ! /* (Internal Only) Database table is empty */
SQLITE_SCHEMA                 Equate(  17)       ! /* The database schema changed */
SQLITE_TOOBIG                 Equate(  18)       ! /* Too much data for one row of a table */
SQLITE_CONSTRAINT             Equate(  19)       ! /* Abort due to contraint violation */
SQLITE_MISMATCH               Equate(  20)       ! /* Data type mismatch */
SQLITE_MISUSE                 Equate(  21)       ! /* Library used incorrectly */
SQLITE_NOLFS                  Equate(  22)       ! /* Uses OS features not supported on host */
SQLITE_AUTH                   Equate(  23)       ! /* Authorization denied */
SQLITE_ROW                    Equate( 100)       ! /* sqlite_step() has another row ready */
SQLITE_DONE                   Equate( 101)       ! /* sqlite_step() has finished executing */

SQLITE_INTEGER                Equate(   1)       !  
SQLITE_FLOAT                  Equate(   2)
SQLITE_TEXT                   Equate(   3)
SQLITE_BLOB                   Equate(   4)
SQLITE_NULL                   Equate(   5)

ERROR_INSUFFICIENT_BUFFER     Equate( 122)       ! The data area passed to a system call is too small.
ERROR_INVALID_FLAGS           Equate(1004)       ! Invalid flags.
ERROR_INVALID_PARAMETER       Equate(  87)       ! The parameter is incorrect.
ERROR_NO_UNICODE_TRANSLATION  Equate(1113)       ! No mapping for the Unicode character exists in the target multi-byte code page.

SQLITE_STATIC                 Equate(   0)
SQLITE_TRANSIENT              Equate(  -1)

! --- SQLite Class

ToySQLite.Construct      Procedure
  Code
  Self.CBQFieldsQ &= New(CBQFieldsQType)
  If  Self.CBQFieldsQ &= Null then TOY::Mess('  CBQFieldsQType',' Construct').

  Self.qRules   &= New(TOY::Q_Rules)  !       
  Self.qFiles   &= New(TOY::Q_Files)  !    Blob

  Self.QueryStr &= NewDynStr()        !   
  Self.FieldStr &= NewDynStr()        !      

ToySQLite.Destruct       Procedure
  Code
  Self.CloseDB()

  If Not (Self.CBQFieldsQ &= Null) then Dispose(Self.CBQFieldsQ).      !      CallBack
  If Not (Self.qRules     &= Null) then Dispose(Self.qRules).          !       
  If Not (Self.qFiles     &= Null) then Dispose(Self.qFiles).          !     Blob
  If Not (Self.QueryStr   &= Null) then DisposeDynStr(Self.QueryStr).  !   
  If Not (Self.FieldStr   &= Null) then DisposeDynStr(Self.FieldStr).  !    

ToySQLite.OpenDB         Procedure(String pDBName, UShort xProgress_ = 0)
Loc:Exists               Byte
Loc:Len                  Long
Loc:DBName               &cString
Loc:DriveLet             String(1)
Loc:DriveNum             Byte
Loc:DriveName            cString(10)
Loc:SectorsPerCluster    Long
Loc:BytesPerSector       Long
Loc:FreeClusters         Long
Loc:Clusters             Long
Loc:ClusterSize          Long
  Code
  Loc:Len = Len(Clip(pDBName))
  If Self.DBName &= Null
     Self.DBName &= New(cString(Loc:Len*3+1))
     Self.DBName  = TOY::ANSItoUTF8(pDBName)
  else
     Loc:DBName  &= New(cString(Loc:Len*3+1))
     Loc:DBName   = TOY::ANSItoUTF8(pDBName)

     If Loc:DBName = Self.DBName and Self.hSQLite  !       
        Dispose(Loc:DBName)
        Return True
     end

     Self.CloseDB()
     Self.DBName &= Loc:DBName
     Loc:DBName  &= Null
  end

  Loc:Exists = Exists(Self.DBName)
  Self.LastReturnCode = sqlite3_open(Self.DBName,Address(Self.hSQLite))
  If Self.LastReturnCode <> SQLITE_OK
     Self.CloseDB()
     Return False
  end

  Self.Exec('PRAGMA synchronous=0')  !0 = Off,     1 = Normal, 2 = Full
  Self.Exec('PRAGMA temp_store=2' )  !0 = Default, 1 = File,   2 = MEMORY

  If ~Loc:Exists
     !Get the Cluster size and set page_size accordingly (NTFS default cluster size is 4096)
     Loc:DriveLet  = Path()
     Loc:DriveNum  = Val(Loc:DriveLet) - 64
     Loc:DriveName = Loc:DriveLet & ':\'
     TOY::GetDiskFreeSpace(Address(Loc:DriveName),         |
                           Address(Loc:SectorsPerCluster), |
                           Address(Loc:BytesPerSector),    |
                           Address(Loc:FreeClusters),      |
                           Address(Loc:Clusters))

     Loc:ClusterSize = Loc:BytesPerSector * Loc:SectorsPerCluster
     If  2^9  = Loc:ClusterSize |  ! 512
     Or  2^10 = Loc:ClusterSize |  !1024
     Or  2^11 = Loc:ClusterSize |  !2048
     Or  2^12 = Loc:ClusterSize |  !4096
     Or  2^13 = Loc:ClusterSize    !8192
         Self.Exec('PRAGMA page_size=' & Loc:ClusterSize)
     end
  end

  Self.ProgressControl = xProgress_  !  
  Return True

ToySQLite.CloseDB        Procedure
  Code
  If Self.hSQLite
     sqlite3_close(Self.hSQLite)
     Self.hSQLite = 0
  end

  If Not (Self.DBName &= Null) then Dispose(Self.DBName).
  Self.ProgressControl = 0  !  

  If Not (Self.CBQFieldsQ &= Null) then Free(Self.CBQFieldsQ).  !      CallBack
  If Not (Self.qRules     &= Null) then Self.FreeRules().       !       
  If Not (Self.qFiles     &= Null) then Self.FreeBlobFiles().   !     Blob
  If Not (Self.QueryStr   &= Null) then Self.QueryStr.Kill.     !   
  If Not (Self.FieldStr   &= Null) then Self.FieldStr.Kill.     !    

!       
ToySQLite.AddEnumTitle   Procedure(*Group xGroup_,Byte fCloseLine_ = False)
FieldName  CString(101)
FieldCount Long(1)  !  
FieldAdded Long(1)  !  
FieldRef   Any
FieldType  CString(8)
  Code
  Loop
    FieldRef &= What(xGroup_,FieldCount)    !   

    If FieldRef &= Null then Break
    elsIf IsGroup(xGroup_,FieldCount) = False
       FieldName = Who(xGroup_,FieldCount)  !  

       If Self.GetRule(FieldName,'Ignore') = False
          If    Self.GetRule(FieldName,'IsFile') = True                           then FieldType = 'BLOB'
          elsIf IsString(FieldRef) = True                                         then FieldType = 'TEXT'
          elsIf (Size(FieldRef) = 8) Or (Self.GetRule(FieldName,'IsReal') = True) then FieldType = 'REAL'
          else                                                                         FieldType = 'INTEGER'.

          If FieldAdded > 1 then Self.QueryStr.Cat(',').
          Self.QueryStr.Cat(FieldName & ' ' & FieldType)
          FieldAdded += 1
       end
    end
    FieldCount += 1
  end
  If fCloseLine_ = True then Self.QueryStr.Cat(')').

!      
ToySQLite.SetEnumField   Procedure(*Group xGroup_,Byte fAddValues_ = False)
FieldName  CString(101)
FieldCount Long(1)  !  
FieldAdded Long(1)  !  
  Code
  Self.FieldStr.Kill
  Loop
    FieldName = Who(xGroup_,FieldCount)
    If FieldName = '' then Break.

    If (Self.GetRule(FieldName,'Ignore') = False) and (IsGroup(xGroup_,FieldCount) = False)
       If FieldAdded > 1 then Self.FieldStr.Cat(',').
       Self.FieldStr.Cat(FieldName)
       FieldAdded += 1
    end
    FieldCount += 1
  end
  If fAddValues_ = True then Self.FieldStr.Cat(') VALUES (').

!       
ToySQLite.AddEnumField   Procedure(<*Group xGroup_>,Byte fAddValues_ = False)
  Code
  If Omitted(xGroup_) = False then Self.SetEnumField(xGroup_,fAddValues_).
  Self.QueryStr.Cat(Self.FieldStr.Str())

!       
ToySQLite.AddEnumValue   Procedure(*Group xGroup_,Byte fCloseLine_ = False)
FieldName  CString(101)
FieldRef   Any
FieldCount Long(1)  !  
FieldAdded Long(1)  !  
  Code
  Loop
    FieldRef &= What(xGroup_,FieldCount)

    If FieldRef &= Null then Break
    elsIf IsGroup(xGroup_,FieldCount) = False

       FieldName = Who(xGroup_,FieldCount)
       If Self.GetRule(FieldName,'Ignore') = False

          If FieldAdded > 1 then Self.QueryStr.Cat(',').

          If Self.GetRule(FieldName,'IsFile') = True
             Self.AddStoreFile(FieldRef,False)               !    BINARY ( )
          elsIf IsString(FieldRef) = True
             Self.QueryStr.Cat(TOY::EscapeString(FieldRef))  !     UTF8
          else
             Self.QueryStr.Cat(Clip(FieldRef))               !   INTEGER / REAL
          end

          FieldAdded += 1
       end
    end
    FieldCount += 1
  end
  If fCloseLine_ = True then Self.QueryStr.Cat(')').

! Callback to update GUI Progress, without any calibration
ToySQLite.Progress       Procedure
  Code
  Self.ProgressCount += 1
  Self.ProgressControl{Prop:Progress} = Self.ProgressCount % 100
  Return 0

!  Blob    Self.qFiles
!   : SELECT ID01,Blob01,ID02,Blob02 FROM MyTable WHERE File = 1
ToySQLite.LoadBlobField  Procedure(String sRequest_)
Loc:Stmt        Long
Loc:AllColumn   ULong,Auto
Loc:StartPoint  ULong,Auto
Loc:LengthBlob  ULong,Auto
Loc:Count       ULong,Auto
Loc:Content     &String

  Code
  If Self.hSQLite then Self.FreeBlobFiles()  !   

     Self.StartWithNew(sRequest_)            !   

     Self.LastReturnCode = sqlite3_prepare(Self.hSQLite, Self.QueryStr.CStr(), Self.QueryStr.StrLen(), Address(Loc:Stmt), 0)
     If Self.LastReturnCode <> SQLITE_OK then TOY::Mess(TOY::UTF8toANSI(Self.QueryStr.Str()) & '|' & Self.ReturnCodeMsg(),' Prepare')
     else
        Loc:AllColumn = sqlite3_column_count(Loc:Stmt)    !  -   

        Loop While sqlite3_step(Loc:Stmt) = SQLITE_ROW    !   
          Loop Loc:Count = 0 to (Loc:AllColumn - 1) by 2  !    : (ID + Blob), (ID + Blob) ...

            Clear(Self.qFiles)  !  

           !Message(sqlite3_column_text( Loc:Stmt,Loc:Count))
            Self.qFiles.ID = sqlite3_column_text( Loc:Stmt,Loc:Count)      ! ID Blob
            Loc:LengthBlob = sqlite3_column_bytes(Loc:Stmt,Loc:Count + 1)  !  Blob
            If (Loc:LengthBlob > 0) and (Self.qFiles.ID <> '')

               Loc:Content &= New(String(Loc:LengthBlob))
               If Not (Loc:Content &= Null)

                  Loc:StartPoint = sqlite3_column_blob(Loc:Stmt,Loc:Count + 1)  !  Blob
                  TOY::MemCpy(Address(Loc:Content),Loc:StartPoint,Loc:LengthBlob)
                  Self.qFiles.Content = Loc:Content
                  Add(Self.qFiles,Self.qFiles.ID)

                  Dispose(Loc:Content)
               end
            end

          end
        end

        sqlite3_finalize(Loc:Stmt)
     end
  end

!         qResponse
ToySQLite.Eviscerate     Procedure(<String sRequest_>,Queue qResponse_,Byte pUseFieldMatching = False) !,Long,Proc
Stmt        Long
AllColumn   ULong,Auto
StartPoint  ULong,Auto
LengthBlob  ULong,Auto
Count       ULong,Auto
Content     &String
FldRef      Any
ColumnType  Long,Auto
ColumnSize  Long,Auto
ColResponse Long,Auto

FieldCount Long(1)  !  
FieldAdded Long(1)  !  

QField     Queue    !     
FieldName    CString(101)  !    qResponse_
FieldColumn  Long          !     SQL 
           end
  Code
  If Self.hSQLite then Self.FreeBlobFiles()  !   
                                             !    ->   
     If Omitted(sRequest_) = False then Self.StartWithNew(sRequest_).
     Free(qResponse_)                        !    

     Self.LastReturnCode = sqlite3_prepare(Self.hSQLite, Self.QueryStr.CStr(), Self.QueryStr.StrLen(), Address(Stmt), 0)
     If Self.LastReturnCode <> SQLITE_OK then TOY::Mess(TOY::UTF8toANSI(Self.QueryStr.Str()) & '||' & Self.ReturnCodeMsg(),' Eviscerate')
     else
        AllColumn = sqlite3_column_count(Stmt)  ! -   
        Loop Count = 0 to (AllColumn - 1)       !     
          Clear(QField)
          QField.FieldName   = Upper(sqlite3_column_name(Stmt,Count))
          QField.FieldColumn = Count
          Add(QField,QField.FieldName)
        end

        Loop While sqlite3_step(Stmt) = SQLITE_ROW   !   

          Clear(qResponse_)

          FieldCount = 1  !    qResponse_
          FieldAdded = 0  !  
          Loop
            Clear(QField)
            QField.FieldName = Upper(Who(qResponse_,FieldCount))
            If QField.FieldName = '' then Break.

            If (Self.GetRule(QField.FieldName,'Ignore') = False) and (IsGroup(qResponse_,FieldCount) = False)

               If pUseFieldMatching = False then ColResponse = FieldAdded  !   
               else
                 Clear(QField)
                 QField.FieldName = Upper(Who(qResponse_,FieldCount))
                 Get(QField,QField.FieldName)
                 If ErrorCode() then ColResponse = -1 else ColResponse = QField.FieldColumn.
               end

               If InRange(ColResponse,0,(AllColumn - 1))  !      

                  FldRef &= What(qResponse_,FieldCount)
                  If Not (FldRef &= Null)

                     Case sqlite3_column_type(Stmt,ColResponse)  !  
                     Of SQLITE_INTEGER
                        FldRef = sqlite3_column_int(Stmt,ColResponse)

                     Of SQLITE_FLOAT
                        FldRef = sqlite3_column_double(Stmt,ColResponse)

                     Of SQLITE_TEXT
                        FldRef = TOY::UTF8toANSI(sqlite3_column_text(Stmt,ColResponse))

                     Of SQLITE_BLOB
                        Clear(Self.qFiles)                                          !  
                        Self.qFiles.ID = TOY::GetGUID()                             ! ID 

                        LengthBlob = sqlite3_column_bytes(Stmt,ColResponse)         !  Blob
                        If (LengthBlob > 0) and (Self.qFiles.ID <> '')

                           Content &= New(String(LengthBlob))                       !  Blob
                           If Not (Content &= Null)
                              StartPoint = sqlite3_column_blob(Stmt,ColResponse)    !  Blob
                              TOY::MemCpy(Address(Content),StartPoint,LengthBlob)   !   Blob
                              Self.qFiles.Content = Content                         !  Blob -> Any Field
                              Dispose(Content)

                              Add(Self.qFiles,Self.qFiles.ID)
                              If ErrorCode() = False then FldRef = Self.qFiles.ID.  ! ID   
                           end
                        end

                     Of SQLITE_NULL
                        !     
                     end

                     !Message(FieldCount & '|' & Who(qResponse_,FieldCount) & '|' & FldRef)
                  end
               end
               FieldAdded += 1
            end
            FieldCount += 1
          end

          Add(qResponse_)
        end

        sqlite3_finalize(Stmt)
     end
  end

  Return True

ToySQLite.InstallBusyHandler Procedure(Long pMilliseconds)
  Code
  SQLite3_busy_timeout(Self.hSQLite,pMilliseconds)

ToySQLite.Callback       Procedure(Long pArgC,Long pArgV,Long pCol)
Loc:ValuePtr   Long
Loc:ColumnPtr  Long
Loc:Column     &cString
Loc:Value      &cString

Loc:Index      Long,Auto
Loc:OffSet     Long(0)
Loc:FldRef     Any

  Code
  Clear(Self.CallbackQ)               !     

  Loop Loc:Index = 1 to pArgC         !   Self.CallbackQ
    Loc:OffSet = 4 * (Loc:Index - 1)  !   

    !    
    TOY::MemCpy(Address(Loc:ValuePtr),pArgV + Loc:OffSet,4)  ! 1st Dereference
    Loc:Value &= (Loc:ValuePtr)                              ! 2nd Dereference

    If Not Self.UseFieldMatching   !     

       !      Self.CallbackQ
       Loc:FldRef &= What(Self.CallbackQ,Loc:Index)
       If ~Loc:FldRef &= Null
          If IsString(Loc:FldRef) and (Clip(Loc:Value) <> '')
             Loc:FldRef = TOY::UTF8toANSI(Loc:Value)  !   UTF8
          else
             Loc:FldRef = Loc:Value                   ! 
          end
       end

    else  !     
       TOY::MemCpy(Address(Loc:ColumnPtr),pCol + Loc:OffSet,4)  !       
       Loc:Column &= (Loc:ColumnPtr)
       Loc:Column  = TOY::UTF8toANSI(Loc:Column)

       Self.CBQFieldsQ.FieldName = Upper(Clip(Loc:Column))      !     Self.CallbackQ    
       Get(Self.CBQFieldsQ,Self.CBQFieldsQ.FieldName)
       If ~ErrorCode()
          Loc:FldRef &= What(Self.CallbackQ,Self.CBQFieldsQ.OrdinalPos)
          If Not (Loc:FldRef &= Null)
             If IsString(Loc:FldRef) and (Clip(Loc:Value) <> '')
                Loc:FldRef = TOY::UTF8toANSI(Loc:Value)  !   UTF8
             else
                Loc:FldRef = Loc:Value                   ! 
             end
          end
       end
    end
  end

  Add(Self.CallbackQ)
  If ~ErrorCode() then Self.CallbackCount += 1.  !      

  If Self.ProgressControl <> 0
     If Self.CallbackCount % Self.ProgressInterval = 0
        Self.ProgressControl{Prop:Progress} = (Self.CallbackCount * 100) / Self.ProgressTotal
     end
  end

  Return SQLITE_OK

!   (      qResponse_  Self.Callback())
ToySQLite.Exec           Procedure(<String sRequest_>,<Queue qResponse_>,Byte pUseFieldMatching = False)
Loc:OrdinalPos   Long
Loc:ErrorMsg     &cString
Loc:ErrorMsgPtr  Long
  Code
  Self.CallBackQ     &= Null
  Self.LastReturnCode = SQLITE_OK
  Loc:ErrorMsgPtr     = 0

  If Omitted(sRequest_)  = False then Self.StartWithNew(sRequest_).  !    ->   
  If Omitted(qResponse_) = False then Self.CallBackQ &= qResponse_.  !        

  If Self.CallBackQ &= Null  ! Self.Callback NOT used
     If Self.ProgressControl <> 0
        Self.ProgressControl{Prop:Range,1}  =   0
        Self.ProgressControl{Prop:Range,2}  = 100
        Self.ProgressControl{Prop:Progress} =   0
        Self.ProgressCount                  =   0
        If Self.ProgressInterval = 0 then Self.ProgressInterval = 1000.  ! Virtual machine opcodes (can only guess)

        sqlite3_progress_handler(Self.hSQLite,Self.ProgressInterval,Address(Self.Progress),Address(Self))
        Self.LastReturnCode = sqlite3_exec(Self.hSQLite,Self.QueryStr.CStr(),0,0,Address(Loc:ErrorMsgPtr))
        sqlite3_progress_handler(Self.hSQLite,0,0,0)

        Self.ProgressControl{Prop:Progress} = 100
        Self.ProgressInterval               =   0
        Self.ProgressControl                =   0
     else
        Self.LastReturnCode = sqlite3_exec(Self.hSQLite,Self.QueryStr.CStr(),0,0,Address(Loc:ErrorMsgPtr))
     end
  else  ! Self.Callback used to populate CallbackQ
     Free(Self.CallBackQ)         !    

     If pUseFieldMatching = True  ! Populate Q using Field Name Matching
        Free(Self.CBQFieldsQ)     !     Self.CallbackQ
        Loop
          Loc:OrdinalPos += 1
          Self.CBQFieldsQ.FieldName  = Upper(Who(Self.CallbackQ,Loc:OrdinalPos))
          If Clip(Self.CBQFieldsQ.FieldName) = '' then Break.
           
          Self.CBQFieldsQ.OrdinalPos = Loc:OrdinalPos
          Add(Self.CBQFieldsQ,Self.CBQFieldsQ.FieldName)
        end

        Self.UseFieldMatching = True
     else
        Self.UseFieldMatching = False  ! Populate Q using Ordinal Number Sequence
     end

     Self.CallbackCount = 0  !      

     If Self.ProgressControl <> 0
        Self.ProgressControl{Prop:Range,1}  =   0
        Self.ProgressControl{Prop:Range,2}  = 100
        Self.ProgressControl{Prop:Progress} =   0
        If Self.ProgressTotal    = 0 then Self.ProgressTotal    = 5000.
        If Self.ProgressInterval = 0 then Self.ProgressInterval = Self.ProgressTotal / 25.
     end

     Self.LastReturnCode = sqlite3_exec(Self.hSQLite,Self.QueryStr.CStr(),Address(Self.Callback),Address(Self),Address(Loc:ErrorMsgPtr))
      
     If Self.ProgressControl <> 0 ! Clean Up
        Self.ProgressControl{Prop:Progress} = 100
        Self.ProgressControl  = 0
        Self.ProgressTotal    = 0
        Self.ProgressInterval = 0
     end

     Self.CallBackQ &= Null
     If Self.UseFieldMatching = True
        Free(Self.CBQFieldsQ)
        Self.UseFieldMatching = False
     end
  end

  If Loc:ErrorMsgPtr
     Loc:ErrorMsg &= (Loc:ErrorMsgPtr)
     TOY::Mess(TOY::UTF8toANSI(Self.QueryStr.Str()) & '||' & Self.ReturnCodeMsg() & '|' & TOY::UTF8toANSI(Loc:ErrorMsg),' Exec 1')
     sqlite3_free(Loc:ErrorMsgPtr)
     Loc:ErrorMsg &= Null
     Return False

  elsIf Self.LastReturnCode <> SQLITE_OK
     TOY::Mess(TOY::UTF8toANSI(Self.QueryStr.Str()) & '||' & Self.ReturnCodeMsg(),' Exec 2')
     Return False
  else
     Return True
  end

!   
ToySQLite.ReturnCodeMsg  Procedure(<Long pCode>)
  Code
  Case Choose(Omitted(pCode) = False,pCode,Self.LastReturnCode)
  Of SQLITE_OK          !Equate(  0)
     Return 'Successful result'
  Of SQLITE_ERROR       !Equate(  1)
     Return 'SQL error or missing database'
  Of SQLITE_INTERNAL    !Equate(  2)
     Return 'An internal logic error in SQLite'
  Of SQLITE_PERM        !Equate(  3)
     Return 'Access permission denied'
  Of SQLITE_ABORT       !Equate(  4)
     Return 'Callback routine requested an abort'
  Of SQLITE_BUSY        !Equate(  5)
     Return 'The database file is locked'
  Of SQLITE_LOCKED      !Equate(  6)
     Return 'A table in the database is locked'
  Of SQLITE_NOMEM       !Equate(  7)
     Return 'A malloc() failed'
  Of SQLITE_READONLY    !Equate(  8)
     Return 'Attempt to write a readonly database'
  Of SQLITE_INTERRUPT   !Equate(  9)
     Return 'Operation terminated by sqlite_interrupt()'
  Of SQLITE_IOERR       !Equate( 10)
     Return 'Some kind of disk I/O error occurred'
  Of SQLITE_CORRUPT     !Equate( 11)
     Return 'The database disk image is malformed'
  Of SQLITE_NOTFOUND    !Equate( 12)
     Return '(Internal Only) Table or record not found'
  Of SQLITE_FULL        !Equate( 13)
     Return 'Insertion failed because database is full'
  Of SQLITE_CANTOPEN    !Equate( 14)
     Return 'Unable to open the database file'
  Of SQLITE_PROTOCOL    !Equate( 15)
     Return 'Database lock protocol error'
  Of SQLITE_EMPTY       !Equate( 16)
     Return '(Internal Only) Database table is empty'
  Of SQLITE_SCHEMA      !Equate( 17)
     Return 'The database schema changed'
  Of SQLITE_TOOBIG      !Equate( 18)
     Return 'Too much data for one row of a table'
  Of SQLITE_CONSTRAINT  !Equate( 19)
     Return 'Abort due to contraint violation'
  Of SQLITE_MISMATCH    !Equate( 20)
     Return 'Data type mismatch'
  Of SQLITE_MISUSE      !Equate( 21)
     Return 'Library used incorrectly'
  Of SQLITE_NOLFS       !Equate( 22)
     Return 'Uses OS features not supported on host'
  Of SQLITE_AUTH        !Equate( 23)
     Return 'Authorization denied'
  Of SQLITE_ROW         !Equate(100)
     Return 'sqlite_step() has another row ready'
  Of SQLITE_DONE        !Equate(101)
     Return 'sqlite_step() has finished executing'
  else
     Return 'Unknown SQLite Code ' & pCode
  end

!   
ToySQLite.StartWithNew   Procedure(String xStr_)
  Code
  Self.QueryStr.Kill
  Self.QueryStr.Cat(xStr_)

!      BLOB 
ToySQLite.FreeBlobFiles  Procedure()
xCount     Long,Auto
  Code
  If Records(Self.qFiles) > 0
     Loop xCount = Records(Self.qFiles) to 1 by -1
       Get(Self.qFiles,xCount)

       If Not (Self.qFiles.Content &= Null) then Self.qFiles.Content &= Null.
       Delete(Self.qFiles)
     end
     Free(Self.qFiles)  ! 
  end

!     qFiles  ID    BLOB 
ToySQLite.ContentToBlob Procedure(String sID_,Blob xBlob_)
  Code
  If Clip(sID_) <> ''
     Clear(Self.qFiles)
     Self.qFiles.ID = Clip(sID_)
     Get(Self.qFiles,Self.qFiles.ID)
     If ~ErrorCode() and ~(Self.qFiles.Content &= Null)
        xBlob_[0:(Len(Self.qFiles.Content) - 1)] = Self.qFiles.Content
        Self.qFiles.Content &= Null
        Delete(Self.qFiles)
     end
  end

!     qFiles  ID    
ToySQLite.ContentToFile Procedure(String sID_,String sFileName)
RetValue  Byte(False)
  Code
  If (Clip(sID_) <> '') and (Clip(sFileName) <> '')

     Clear(Self.qFiles)
     Self.qFiles.ID = Clip(sID_)
     Get(Self.qFiles,Self.qFiles.ID)
     If ~ErrorCode() and ~(Self.qFiles.Content &= Null)
        RetValue = TOY::WriteStrToFile(sFileName,Self.qFiles.Content)
        Self.qFiles.Content &= Null
        Delete(Self.qFiles)
     end
  end
  Return RetValue

!     BLOB   
ToySQLite.AddStoreFile   Procedure(String xFileName_,Byte xAddSeparator_ = True)
zCount    Long,Auto
zStrRef1  &String
zStrRef2  &String
  Code
  If xAddSeparator_ = True then Self.QueryStr.Cat(','). !   

  If    Clip(xFileName_)         = ''    then Self.QueryStr.Cat('X''''')  !    
  elsIf Exists(Clip(xFileName_)) = False then Self.QueryStr.Cat('X''''')  !   
  else
     zStrRef1    &= TOY::LoadStrFromFile(xFileName_)
     If zStrRef1 &= Null then Self.QueryStr.Cat('X''''')
     else
        If Not InRange(Size(zStrRef1),1,TOY::MaxSizeBlob) then Self.QueryStr.Cat('X''''')  !    
        else
           zStrRef2    &= New(String(Size(zStrRef1) * 2))
           If zStrRef2 &= Null then Self.QueryStr.Cat('X''''')
           else
              Loop zCount = 1 to Size(zStrRef1)           !        BIN
                zStrRef2[((zCount * 2) - 1):(zCount * 2)] = ByteToHex(Val(zStrRef1[zCount]),0)
              end
              Self.QueryStr.Cat('X''' & zStrRef2 & '''')  !    BINARY    BLOB 
              Dispose(zStrRef2)
           end
        end
        Dispose(zStrRef1)
     end
  end

!      
ToySQLite.FreeRules      Procedure
  Code
  Free(Self.qRules)

!    
ToySQLite.SetRule        Procedure(String sFieldName,String sRuleName,Byte fRuleValue)
  Code
  Clear(Self.qRules)
  Self.qRules.FieldName = Upper(Clip(Left(sFieldName)))
  Get(Self.qRules,Self.qRules.FieldName)
  If ErrorCode()  !     -> 
     Clear(Self.qRules)
     Self.qRules.FieldName = Upper(Clip(Left(sFieldName)))
     Add(Self.qRules,Self.qRules.FieldName)
  end

  Case Upper(Clip(Left(sRuleName)))
  Of 'ISFILE'
     Self.qRules.IsFile = fRuleValue
  Of 'ISREAL'
     Self.qRules.IsReal = fRuleValue
  Of 'IGNORE'
     Self.qRules.Ignore = fRuleValue
  end

  Put(Self.qRules,Self.qRules.FieldName)

!     
ToySQLite.GetRule        Procedure(String sFieldName,String sRuleName) !,Byte
RetValue  Byte(False)
  Code
  Clear(Self.qRules)
  Self.qRules.FieldName = Upper(Clip(Left(sFieldName)))
  Get(Self.qRules,Self.qRules.FieldName)
  If ErrorCode() then Clear(Self.qRules)
  else
     Case Upper(Clip(Left(sRuleName)))
     Of 'ISFILE'
        RetValue = Self.qRules.IsFile
     Of 'ISREAL'
        RetValue = Self.qRules.IsReal
     Of 'IGNORE'
        RetValue = Self.qRules.Ignore
     end
  end

  Return RetValue

!    
ToySQLite.QueueToTable   Procedure(Queue qList_,String sTableName_,Short xProgress_ = -1)
xCount     Long,Auto
xIndicator Long,Auto
  Code
  If xProgress_ <> -1 then xIndicator = xProgress_{Prop:Progress}.

  Self.SetEnumField(qList_,True)      !       + ') VALUES ('

  Loop xCount = 1 to Records(qList_)  !  
    Get(qList_,xCount)

    Self.StartWithNew('INSERT INTO ' & sTableName_ & ' (')
    Self.AddEnumField()               !          SetEnumField()
    Self.AddEnumValue(qList_,True)    !     + ')'
    If Not Self.Exec() then TOY::Mess('     SQLite: ' & sTableName_,' QueueToTable').

    If xProgress_ <> -1 then xIndicator += 1
       If (xIndicator % 100) = 0 then xProgress_{Prop:Progress} = xIndicator.
    end
  end

! ---  

!    
TOY::EscapeString  Procedure(String pStr)  !,String
RetValue           String(Size(pStr) * 2)
LastIndex          Long(1)
FindIndex          Long,Auto
CharQuote          String('''') ! ('"')
  Code
  RetValue = pStr
  Loop
    FindIndex = InString(CharQuote,Clip(RetValue),1,LastIndex)
    If InRange(FindIndex,1,Size(RetValue) - 1) = False then Break
    else
       RetValue  = RetValue[1:FindIndex] & CharQuote & Clip(RetValue[(FindIndex + 1):Size(RetValue)])
       LastIndex = FindIndex + 2
    end
  end

  Return CharQuote & TOY::ANSItoUTF8(Clip(RetValue)) & CharQuote

!  GUID-36
TOY::GetGUID          Procedure !,String
pGuid       String(16)
buf         String(128)
buf2        String(64)
cbSize      Long
xRetValue   String(36)
  Code
  If ~TOY::CoCreateGuid(pGUID)
     If TOY::StringFromGuid2(pGuid, buf, SIZE(buf)/2)
        cbSize = TOY::WideCharToMultiByte(, , Address(buf), -1, Address(buf2), SIZE(buf2), 0, 0)
        If cbSize > 0 then xRetValue = buf2[2 : 37].
     end
  end

  Return xRetValue

!    
TOY::LoadStrFromFile  Procedure(String sFileName)  !,&String
xFileName       CString(File:MaxFileName)
sData           &String
hFile           Long,Auto
dwFileSize      Long,Auto
lpFileSizeHigh  Long
dwBytesRead     Long
bRead           Bool,Auto
  Code
  If Clip(Left(sFileName)) = '' then TOY::Mess('     !','LoadStrFromFile')
  else
     xFileName = LongPath(Clip(sFileName))
     hFile = TOY::CreateFile(xFileName,GENERIC_READ,0,0,OPEN_EXISTING,0,0)
     If hFile = INVALID_HANDLE_VALUE then TOY::Mess('   : ' & TOY::GetLastError(),'LoadStrFromFile')
     else
        dwFileSize = TOY::GetFileSize(hFile,lpFileSizeHigh)
        If dwFileSize > 0
           sData &= New String(dwFileSize)
           bRead  = TOY::ReadFile(hFile,Address(sData),dwFileSize,dwBytesRead,0)
        end
        TOY::CloseHandle(hFile)
     end
  end
  Return sData

!    
TOY::WriteStrToFile  Procedure(String sFileName,String sData)
xFileName       CString(File:MaxFileName)
RetValue        Byte(False)
hFile           Long,Auto
RC              Long,Auto
dwBytesWritten  Long
  Code

  If Clip(Left(sFileName)) = '' then TOY::Mess('     !','WriteStrToFile')
  else
     xFileName = LongPath(Clip(sFileName))
     hFile     = TOY::CreateFile(xFileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0)  !    ,      ReadOnly !!!

     If hFile = INVALID_HANDLE_VALUE then TOY::Mess('    : ' & TOY::GetLastError(),'WriteStrToFile')
     else
        RC = TOY::WriteFile(hFile, sData, Size(sData), dwBytesWritten, 0)
        TOY::CloseHandle(hFile)

        If RC then RetValue = True
        else
           TOY::Mess('  : ' & TOY::GetLastError(),'WriteStrToFile')
        end
     end
  end

  Return RetValue

!    ANSI -> UTF8
TOY::ANSItoUTF8       Procedure(String sStr)  !,String
UnicodeText   String(Size(sStr)*2+2)
UtfText       String(Size(sStr)*2+2)
bytesWritten  Long, Auto
pLen          Long, Auto
  Code
  If            Clip(sStr) = '' then Return ''
  elsIf Numeric(Clip(sStr))     then Return Clip(sStr)
  else
     bytesWritten = TOY::MultiByteToWideChar(TOY::GetACP(),0,Address(sStr),       Len(sStr),   Address(UnicodeText),Size(UnicodeText))
     pLen = TOY::WideCharToMultiByte(        65001,        0,Address(UnicodeText),bytesWritten,Address(UTFText),    Size(UTFText),0,0)
     Return UtfText[1 : pLen]
  end

!    UTF8 -> ANSI
TOY::UTF8toANSI       Procedure(String sStr)  !,String
UnicodeText   String(Size(sStr)*2+2)
ANSIText      String(Size(sStr)*2+2)
bytesWritten  Long, Auto
Len           Long, Auto
  Code
  If (Size(sStr) = 0) Or (sStr = '<0>') then Return ''
  else
     bytesWritten = TOY::MultiByteToWideChar(65001,        0,Address(sStr),       Len(sStr),   Address(UnicodeText),Size(UnicodeText))
     Len          = TOY::WideCharToMultiByte(TOY::GetACP(),0,Address(UnicodeText),bytesWritten,Address(ANSIText),   Size(ANSIText),0,0)
     If Len <= 0 then Return ''
     else
        Loop
          If Sub(ANSIText,Len,1) = '<0>' then Len -= 1 else Break.
        end
        Return Sub(ANSIText,1,Len)
     end
  end

! 
TOY::Mess             Procedure(String sText,String sScene)
  Code
  Message(Clip(sText),sScene,Icon:Exclamation,'&1. ')