!** SQLite for Clarion (Fork)
!** Date version:  04.02.2023
!** SQLiteType (C) John Taylor, 2007
!** ToySQLite  (C) Igor Joiner, 2023

! Ignore, IsReal

  Include('DynStr.inc'),Once   !  .
  Include('svapi.inc'), Once   !  WinAPI

  Map
    Module('tSQLite')          !  
      TOY::EscapeString(String pStr),String  !    
    end
  end

TOY::Q_Files    Queue,Type     !   
ID                CString(37)  ! ID 
Content           Any
                end

TOY::Q_Rules    Queue,Type     !       
FieldName         CString(101) !  
IsFile            Byte(False)  !   -   BLOB  
IsReal            Byte(False)  !   - REAL ( DECIMAL / PDECIMAL)
Ignore            Byte(False)  !    
                end

CBQFieldsQType  Queue,Type    !      CallBackQ
OrdinalPos        Long
FieldName         CString(101)
                end

!ToySQLite      Class,Type,Thread,Module('SQLite.CLW'),Link('SQLite.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)
ToySQLite       Class,Type,Thread,Module('tSQLite.CLW'),Link('tSQLite.CLW',1),DLL(0)
Construct           Procedure(),Private
Destruct            Procedure(),Private
Callback            Procedure(Long pArgC,Long pArgV,Long pCol),Long,C,Private
Progress            Procedure(),Long,C,Private

OpenDB              Procedure(String, UShort xProgress_ = 0),Long
CloseDB             Procedure()
Exec                Procedure(<String sRequest_>,<Queue qResponse_>,Byte pUseFieldMatching = False),Long,Proc
ReturnCodeMsg       Procedure(<Long pCode>),String
InstallBusyHandler  Procedure(Long)

CBQFieldsQ          &CBQFieldsQType,Private                   !      CallBackQ
UseFieldMatching    Byte(False),Private

CallbackQ           &Queue,Private
CallbackCount       Long
ProgressCount       Long
ProgressControl     Long,Private                              !  
ProgressTotal       Long
ProgressInterval    Long
hSQLite             ULong,Private
DBName              &cString,Private
LastReturnCode      Long

! Fork

qFiles              &TOY::Q_Files,Private               !    BLOB 
qRules              &TOY::Q_Rules,Private               !       
QueryStr            &IDynStr                            !  
FieldStr            &IDynStr                            !      

FreeBlobFiles       Procedure(),Private                 !    qFiles
LoadBlobField       Procedure(String sRequest_)         !  BLOB    qFiles
ContentToBlob       Procedure(String sID_,Blob xBlob_)  !     qFiles  ID    Blob 
                                                        !     qFiles  ID    
ContentToFile       Procedure(String sID_,String sFileName),Byte,Proc

StartWithNew        Procedure(String xStr_)             !    
                                                        !                   
SetEnumField        Procedure(*Group xGroup_,  Byte fAddValues_ = False)
                                                        !           
AddEnumField        Procedure(<*Group xGroup_>,Byte fAddValues_ = False)
                                                        !       
AddEnumTitle        Procedure(*Group xGroup_,Byte fCloseLine_ = False)
                                                        !        
AddEnumValue        Procedure(*Group xGroup_,Byte fCloseLine_ = False)
                                                        !     BLOB   
AddStoreFile        Procedure(String xFileName_,Byte xAddSeparator_ = True)
                                                        !     ( Exec(),    BLOB  qFiles)
Eviscerate          Procedure(<String sRequest_>,Queue qResponse_,Byte pUseFieldMatching = False),Long,Proc

FreeRules           Procedure()                         !      
                                                        !    
SetRule             Procedure(String sFieldName,String sRuleName,Byte fRuleValue)
                                                        !     
GetRule             Procedure(String sFieldName,String sRuleName),Byte
                                                        !    
QueueToTable        Procedure(Queue qList_,String sTableName_,Short xProgress_ = -1)
                end